> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Call Logs

> Call Logs — CometChat documentation.

## Overview

`CometChatCallLogs` is a [Component](/docs/ui-kit/angular/v4/components-overview#components) that shows the list of Call Log available . By default, names are shown for all listed users, along with their avatar if available.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/czi9y0KbDwCW-4OY/images/6d5758be-call_logs_overview_web_screens-d1bd9a2728f9be275e6f10f00e377f10.png?fit=max&auto=format&n=czi9y0KbDwCW-4OY&q=85&s=6746bf0836687d10cf97928cbddd8769" width="3600" height="2400" data-path="images/6d5758be-call_logs_overview_web_screens-d1bd9a2728f9be275e6f10f00e377f10.png" />
</Frame>

The `Call Logs` is comprised of the following components:

| Components                                        | Description                                                                                                                 |
| ------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------- |
| CometChatList                                     | a reusable container component having title, search box, customisable background and a List View                            |
| [cometchat-backdrop](/docs/ui-kit/angular/v4/backdrop) | This element represents the background against which other elements are presented.                                          |
| [CometChatListItem](/docs/ui-kit/angular/v4/list-item) | a component that renders data obtained from a Group object on a Tile having a title, subtitle, leading and trailing view    |
| [cometchat-date](/docs/ui-kit/angular/v4/date)         | This Component used to show the date and time. You can also customize the appearance of this widget by modifying its logic. |
| cometchat-button                                  | This component represents a button with optional icon and text.                                                             |

## Usage

### Integration

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import { CometChatCallLogs } from "@cometchat/chat-uikit-angular";
    import { AppComponent } from "./app.component";

    @NgModule({
      imports: [BrowserModule, CometChatCallLogs],
      declarations: [AppComponent],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>

  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs> </cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/docs/ui-kit/angular/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

##### 1. onItemClick

`OnItemClick` is triggered when you click on a ListItem of the Call Logs component. By default it initiate a call to the participant associated with the respective ListItem. You can override this action using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public handleOnItemClick = (call: any) =>{
        console.log("your custom on item click");
      };
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [onItemClick]="handleOnItemClick"></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

##### 2. onInfoClick

`onInfoClick` is triggered when you click the Info button Icon of the `Call Logs` component. It does not have a default behavior. However, you can override its behavior using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public handleOnInfoClick = (call: any) => {
        console.log("your custom on info click actions", call);
      }
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [onInfoClick]="handleOnInfoClick"></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

##### 3. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the Call Logs component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public handleOnError = (error: CometChat.CometChatException) => {
        console.log("your custom on error action", error);
      };
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [onError]="handleOnError"></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a `Component`. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using `RequestBuilders` of Chat SDK.

##### 1. CallLogRequestBuilder

The [CallLogRequestBuilder](/docs/sdk/javascript/call-logs) enables you to filter and customize the Call Log based on available parameters in [CallLogRequestBuilder](/docs/sdk/javascript/call-logs). This feature allows you to create more specific and targeted queries when fetching the call logs. The following are the parameters available in [CallLogRequestBuilder](/docs/sdk/javascript/call-logs)

| Methods              | Type       | Description                                                  |
| -------------------- | ---------- | ------------------------------------------------------------ |
| **setLimit**         | number     | Specifies the number of call logs to fetch.                  |
| **setCallType**      | String     | Sets the type of calls to fetch (call or meet).              |
| **setCallStatus**    | callStatus | Sets the status of calls to fetch (initiated, ongoing, etc.) |
| **setHasRecording**  | boolean    | Sets whether to fetch calls that have recordings.            |
| **setCallCategory**  | string     | Sets the category of calls to fetch (call or meet).          |
| **setCallDirection** | string     | Sets the direction of calls to fetch (incoming or outgoing)  |
| **setUid**           | string     | Sets the UID of the user whose call logs to fetch.           |
| **setGuid**          | string     | Sets the GUID of the user whose call logs to fetch.          |
| **setAuthToken**     | string     | Sets the Auth token of the logged-in user.                   |

**Example**

In the example below, we're filtering Call Logs to show only canceled calls and setting the limit to five.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { CallLogRequestBuilder } from '@cometchat/calls-sdk-javascript';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      callLogRequestBuilder = new CallLogRequestBuilder().setAuthToken("authtoken").setLimit(5).setCallStatus("cancelled")

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs
        [callLogRequestBuilder]="callLogRequestBuilder"
      ></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/docs/ui-kit/angular/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The list of events emitted by the `Call Logs` component is as follows.

| Event             | Description                                                                                               |
| ----------------- | --------------------------------------------------------------------------------------------------------- |
| **ccMessageSent** | This event is triggered when the sent message is in transit and also when it is received by the receiver. |

***

Adding `CometChatCallEvents` Listener's

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    import {CometChatCallEvents} from "@cometchat/chat-uikit-angular";

    this.ccMessageSent = CometChatCallEvents.ccMessageSent.subscribe(
      () => {
            // Your Code
      }
    );
    ```
  </Tab>
</Tabs>

***

Removing `CometChatCallEvents` Listener's

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    this.ccMessageSent.unsubscribe();
    ```
  </Tab>
</Tabs>

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Call Logs component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using Style you can customize the look and feel of the component in your app, These parameters typically control elements such as the color, size, shape, and fonts used within the component.

##### 1. CallLogs Style

To customize the appearance, you can assign a `CallLogsStyle` object to the `Call Logs` component.

**Example**

In this example, we are employing the `callLogsStyle`.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { CallLogsStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      callLogsStyle = new CallLogsStyle({
        background: "#dac6f5",
        titleColor: "#000000",
        dateTextColor: "#dac6f5",
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [callLogsStyle]="callLogsStyle"></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bKHmaxDqzaJZWwLS/images/45a531d0-call_logs_style_web_screens-9a6dbef33948ea7e0df0cc0e679da14f.png?fit=max&auto=format&n=bKHmaxDqzaJZWwLS&q=85&s=112e114ab0936a315c5751e4902178a7" width="3600" height="2400" data-path="images/45a531d0-call_logs_style_web_screens-9a6dbef33948ea7e0df0cc0e679da14f.png" />
</Frame>

***

The following properties are exposed by `CallLogsStyle`:

| Property                   | Description                           | Code                               |
| -------------------------- | ------------------------------------- | ---------------------------------- |
| **border**                 | Used to set border                    | `border?: string,`                 |
| **borderRadius**           | Used to set border radius             | `borderRadius?: string;`           |
| **background**             | Used to set background colour         | `background?: string;`             |
| **height**                 | Used to set height                    | `height?: string;`                 |
| **width**                  | Used to set width                     | `width?: string;`                  |
| **titleFont**              | Used to set title font                | `titleFont?: string,`              |
| **titleColor**             | Used to set title color               | `titleColor?: string;`             |
| **emptyStateTextColor**    | Used to set empty state text color    | `emptyStateTextColor?: string;`    |
| **emptyStateTextFont**     | Used to set empty state text font     | `emptyStateTextFont?: string;`     |
| **errorStateTextColor**    | Used to set error state text color    | `errorStateTextColor?: string;`    |
| **errorStateTextFont**     | Used to set error state text font     | `errorStateTextFont?: string;`     |
| **loadingIconTint**        | Used to set loading icon tint         | `loadingIconTint?: string;`        |
| **infoIconTint**           | Used to set info icon tint            | `infoIconTint?: string;`           |
| **missedCallIconTint**     | Used to set missed call icon tint     | `missedCallIconTint?: string;`     |
| **outgoingCallIconTint**   | Used to set outgoing call icon tint   | `outgoingCallIconTint?: string;`   |
| **incomingCallIconTint**   | Used to set incoming call icon tint   | `incomingCallIconTint?: string;`   |
| **callStatusTextFont**     | Used to set call status text font     | `callStatusTextFont?: string;`     |
| **callStatusTextColor**    | Used to set call status text color    | `callStatusTextColor?: string;`    |
| **dateTextFont**           | Used to set date text font            | `dateTextFont?: string;`           |
| **dateTextColor**          | Used to set date text color           | `dateTextColor?: string;`          |
| **dateSeparatorTextFont**  | Used to set date separator text font  | `dateSeparatorTextFont?: string;`  |
| **dateSeparatorTextColor** | Used to set date separator text color | `dateSeparatorTextColor?: string;` |

##### 2. Avatar Style

If you want to apply customized styles to the `Avatar` component within the `Call Logs` Component, you can use the following code snippet. For more information you can refer [Avatar Styles](/docs/ui-kit/angular/v4/avatar#avatar-style).

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, AvatarStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff"
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [avatarStyle]="avatarStyle"></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

##### 3. ListItem Style

If you want to apply customized styles to the `List Item` component within the `Call Logs` Component, you can use the following code snippet. For more information, you can refer [ListItem Styles](/docs/ui-kit/angular/v4/list-item#listitemstyle).

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding: "5px",
        border: "1px solid #e9b8f5",
        titleColor: "#8830f2",
        borderRadius: "20px",
        width: "100% !important"
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [listItemStyle]="listItemStyle"></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

Here is a code snippet demonstrating how you can customize the functionality of the `Call Logs` component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { DatePatterns } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public datePattern: DatePatterns = DatePatterns.DateTime;

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs
        [title]="'Your Custom Title'"
        [datePattern]="datePattern"
        [hideSeparator]="false"
      ></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Relz_yItqW5RHUsU/images/4e0b95ab-call_logs_functionality_default_web_screens-0853f993061a9b9b0d224c3d625afd7b.png?fit=max&auto=format&n=Relz_yItqW5RHUsU&q=85&s=28ad9268ec0e6269f13d896bd2d170e1" width="3600" height="2400" data-path="images/4e0b95ab-call_logs_functionality_default_web_screens-0853f993061a9b9b0d224c3d625afd7b.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/LKT8U_07JOWQgTZK/images/0d1ae652-call_logs_functionality_custom_web_screens-f1c16f2cc45fa0add6c194f52322b458.png?fit=max&auto=format&n=LKT8U_07JOWQgTZK&q=85&s=92afdd6d315881abb69015a22ecd9d42" width="3600" height="2400" data-path="images/0d1ae652-call_logs_functionality_custom_web_screens-f1c16f2cc45fa0add6c194f52322b458.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                     | Description                                        | Code                                                       |
| ---------------------------- | -------------------------------------------------- | ---------------------------------------------------------- |
| **title**                    | Used to set custom title                           | `[title]="'Your Custom Title'"`                            |
| **emptyStateText**           | Used to set custom empty state text                | `[emptyStateText]="'Your Custom Empty State Text'"`        |
| **errorStateText**           | Used to set custom error state text                | `[errorStateText]="'Your Custom Error State Text'"`        |
| **titleAlignment**           | Used to set custom title alignment                 | `[titleAlignment]="titleAlignment"`                        |
| **datePattern**              | Used to set custom date pattern                    | `[datePattern]="datePattern"`                              |
| **dateSeparatorPattern**     | Used to set custom date separator pattern          | `[dateSeparatorPattern]="dateSeparatorPattern"`            |
| **infoIconUrl**              | Used to set custom info icon                       | `[infoIconUrl]="infoIconURL"`                              |
| **incomingAudioCallIconUrl** | Used to set custom incoming audio call icon        | `[incomingAudioCallIconUrl]="incomingAudioCallIconUrl"`    |
| **missedAudioCallIconUrl**   | Used to set custom missed audio call icon          | `[missedAudioCallIconUrl]="missedAudioCallIconUrl"`        |
| **missedVideoCallIconUrl**   | Used to set custom missed video call icon          | `[missedVideoCallIconUrl]='Custom Missed Video Call Icon'` |
| **incomingVideoCallIconUrl** | Used to set custom incoming video call icon        | `[incomingVideoCallIconUrl]="incomingVideoCallIconUrl"`    |
| **outgoingAudioCallIconUrl** | Used to set custom outgoing audio call icon        | `[outgoingAudioCallIconUrl]="outgoingAudioCallIconUrl"`    |
| **outgoingVideoCallIconUrl** | Used to set custom outgoing video call icon        | `[outgoingVideoCallIconUrl]="outgoingVideoCallIconUrl"`    |
| **loadingIconURL**           | Used to set custom loading icon                    | `[loadingIconURL]="loadingIconURL"`                        |
| **hideSeparator**            | Option to hide separator                           | `[hideSeparator]="false"`                                  |
| **activeCall**               | Used to set active Call that is currently selected | `[activeCall]="callObject"`                                |

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### ListItemView

With this property, you can assign a custom ListItem to the Call Logs Component.

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/6twnUcGNOB9c0CI0/images/ea2a27d3-call_logs_list_item_view_default_web_screens-506fa090bed2b8bf2afc7e9359467ef7.png?fit=max&auto=format&n=6twnUcGNOB9c0CI0&q=85&s=d711d6868832960cb8726eb875dd0527" width="3600" height="2400" data-path="images/ea2a27d3-call_logs_list_item_view_default_web_screens-506fa090bed2b8bf2afc7e9359467ef7.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tI1D0nyKUVcz2LEZ/images/c32ca3ec-call_logs_list_item_view_custom_web_screens-65efd5bab911e5af186833b607c06c33.png?fit=max&auto=format&n=tI1D0nyKUVcz2LEZ&q=85&s=59e70a25fc50d6eb1306cde9006d16c1" width="3600" height="2400" data-path="images/c32ca3ec-call_logs_list_item_view_custom_web_screens-65efd5bab911e5af186833b607c06c33.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs
        [listItemView]="listItemViewTemplate"
      ></cometchat-call-logs>
    </div>
    <ng-template #listItemViewTemplate let-call>
      <div
        [ngStyle]="{
        display: 'flex',
        alignItems: 'left',
        padding: '10px',
        border: '2px solid #e9baff',
        borderRadius: '20px',
        background: '#6e2bd9'
      }"
      >
        <cometchat-avatar
          [image]="call.getInitiator().getAvatar()"
          [name]="call.getInitiator().getName()"
        ></cometchat-avatar>
        <div [ngStyle]="{ display: 'flex', paddingLeft: '10px' }">
          <div
            [ngStyle]="{ fontWeight: 'bold', color: '#ffffff', fontSize: '14px' }"
          >
            {{ call.getInitiator().getName() }}
          </div>
        </div>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### SubtitleView

You can customize the subtitle view for each call logs item to meet your requirements

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d228d043-call_logs_subtitle_view_default_web_screens-64218d28454cbb8ad6dad843f49f6e1b.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=4623a539e69181c293f302bfaa831d57" width="3600" height="2400" data-path="images/d228d043-call_logs_subtitle_view_default_web_screens-64218d28454cbb8ad6dad843f49f6e1b.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/DVg4aTljRFe0drLF/images/23667da7-call_logs_subtitle_view_custom_web_screens-38ac66906d044da9b6f34efc23348ecd.png?fit=max&auto=format&n=DVg4aTljRFe0drLF&q=85&s=123a183ba8809d4d27580865d5255699" width="3600" height="2400" data-path="images/23667da7-call_logs_subtitle_view_custom_web_screens-38ac66906d044da9b6f34efc23348ecd.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [subtitleView]="subtitleTemplate"></cometchat-call-logs>
    </div>
    <ng-template #subtitleTemplate>
      <div
        style="display: flex; align-items: left; padding: 10px; font-size: 10px;"
      >
        your custom subtitle view
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### TailView

You can customize the tail view for each call logs item to meet your requirements

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/dDWpooIQ48haNjyU/images/7ab55640-call_logs_tailview_view_default_web_screens-5d23ec8c3c43e4d85b19db5c631ef366.png?fit=max&auto=format&n=dDWpooIQ48haNjyU&q=85&s=a69e886e8175344e906f081df99eafc3" width="3600" height="2400" data-path="images/7ab55640-call_logs_tailview_view_default_web_screens-5d23ec8c3c43e4d85b19db5c631ef366.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f42b1867-call_logs_tailview_view_custom_web_screens-0d61ad57a621b1e478592e2a4cdbf3da.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=563da6dc987d2a9f4123878251abb164" width="3600" height="2400" data-path="images/f42b1867-call_logs_tailview_view_custom_web_screens-0d61ad57a621b1e478592e2a4cdbf3da.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [tailView]="tailViewTemplate"></cometchat-call-logs>
    </div>
    <ng-template #tailViewTemplate>
      <div
        [ngStyle]="{
        color: '#5a00a8',
        border: '1px solid #5a00a8',
        borderRadius: '12px',
        padding: '5px'
      }"
      >
        your custom tailview
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### LoadingStateView

You can set a custom loader view using `loadingStateView` to match the loading view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bKHmaxDqzaJZWwLS/images/45d3fdab-call_logs_loading_state_view_default_web_screens-e351ed40e0407382e07795621703c7f4.png?fit=max&auto=format&n=bKHmaxDqzaJZWwLS&q=85&s=eefba025c478444d6817e9037ce3140b" width="3600" height="2400" data-path="images/45d3fdab-call_logs_loading_state_view_default_web_screens-e351ed40e0407382e07795621703c7f4.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_oiGBuX1qG3S8Eo5/images/621fc1f7-call_logs_loading_state_view_custom_web_screens-bb7b4139c66933617278a187dbe17973.png?fit=max&auto=format&n=_oiGBuX1qG3S8Eo5&q=85&s=e0d80d7c75a02734013f624d5e771997" width="3600" height="2400" data-path="images/621fc1f7-call_logs_loading_state_view_custom_web_screens-bb7b4139c66933617278a187dbe17973.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, LoaderStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      getLoaderStyle: LoaderStyle = new LoaderStyle({
        iconTint: "red",
        background: "transparent",
        height: "20px",
        width: "20px",
        border: "none",
        borderRadius: "0",
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs
        [loadingStateView]="loadingStateView"
      ></cometchat-call-logs>
    </div>
    <ng-template #loadingStateView>
      <cometchat-loader
        iconURL="icon"
        [loaderStyle]="getLoaderStyle"
      ></cometchat-loader>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### EmptyStateView

You can set a custom `EmptyStateView` using `emptyStateView` to match the empty view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/60KLvpM3Vx0byZeU/images/b71469f2-call_logs_empty_state_view_default_web_screens-c4ed8bfc7bc5278ef644505b9b3d010e.png?fit=max&auto=format&n=60KLvpM3Vx0byZeU&q=85&s=8d65373ce3fea0a11579e697aaa08610" width="3600" height="2400" data-path="images/b71469f2-call_logs_empty_state_view_default_web_screens-c4ed8bfc7bc5278ef644505b9b3d010e.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/iII-209mTdOytBSH/images/ee855e70-call_logs_empty_state_view_custom_web_screens-98d26242514a65dbfbf6fc41b0e9bf2f.png?fit=max&auto=format&n=iII-209mTdOytBSH&q=85&s=2c88c1bb4d0e9788c9c53f337a4d525e" width="3600" height="2400" data-path="images/ee855e70-call_logs_empty_state_view_custom_web_screens-98d26242514a65dbfbf6fc41b0e9bf2f.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [emptyStateView]="emptyStateView"></cometchat-call-logs>
    </div>
    <ng-template #emptyStateView>
      <div>Your Custom Empty State</div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### ErrorStateView

You can set a custom `ErrorStateView` using `errorStateView` to match the error view of your app.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs [errorStateView]="errorStateView"></cometchat-call-logs>
    </div>
    <ng-template #errorStateView>
      <div style="height: 100vh; width: 100vw">
        <img
          src="icon"
          alt="error icon"
          style="height:100px; width: 100px; justify-content: center; margin-top: 250px; margin-right: 700px;"
        />
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

## Configurations

[Configurations](/docs/ui-kit/angular/v4/components-overview#configurations) offer the ability to customize the properties of each component within a Composite Component.

CometChatCallLogs has `OutGoing Call` component. Hence, each of these components will have its individual \`Configuration\`\`.

* `Configurations` expose properties that are available in its individual components.

#### OutGoing Call

You can customize the properties of the OutGoing Call component by making use of the `OutgoingCallConfiguration`.

All exposed properties of `OutgoingCallConfiguration` can be found under [OutGoing Call](/docs/ui-kit/angular/v4/outgoing-call#functionality). Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the OutGoing Call subcomponent and, in addition, you want to change the decline button icon.

You can modify the style using the `outgoingCallStyle` property and set custom decline button icon using `declineButtonIconURL` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/FdElFhttTImVJEz7/images/e3e289c6-call_logs_outgoingcall_configuration_web_screens-1140f57d7ebed6c965f357d63aa35c7f.png?fit=max&auto=format&n=FdElFhttTImVJEz7&q=85&s=f5dc398de8763c29a766c6f32ab455df" width="3600" height="2400" data-path="images/e3e289c6-call_logs_outgoingcall_configuration_web_screens-1140f57d7ebed6c965f357d63aa35c7f.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { OutgoingCallConfiguration, OutgoingCallStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      outgoingCallStyle = new OutgoingCallStyle({
        background: "#e0d5f5",
        declineButtonIconBackground: "#6830d1",
        height: "500px",
        width: "300px",
        declineButtonTextColor: "#ffffff",
        titleTextColor: "#ffffff",
        subtitleTextColor: "#9213d6",
        declineButtonIconTint: "#dbb1f2",
        border: "1px solid #e6e6e6",
        borderRadius: "12px",
      });
      public outgoingCallConfiguration = new OutgoingCallConfiguration({
         //override properties of out going call
         outgoingCallStyle: this.outgoingCallStyle,
         declineButtonIconURL: 'declineButtonIconURL',
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-call-logs
        [outgoingCallConfiguration]="outgoingCallConfiguration"
      ></cometchat-call-logs>
    </div>
    ```
  </Tab>
</Tabs>

***


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Call Logs

> Call Logs — CometChat documentation.

## Overview

`CometChatCallLogs` is a [Component](/ui-kit/react/v4/components-overview#components) that shows the list of Call Log available . By default, names are shown for all listed users, along with their avatar if available.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/czi9y0KbDwCW-4OY/images/6d5758be-call_logs_overview_web_screens-d1bd9a2728f9be275e6f10f00e377f10.png?fit=max&auto=format&n=czi9y0KbDwCW-4OY&q=85&s=6746bf0836687d10cf97928cbddd8769" width="3600" height="2400" data-path="images/6d5758be-call_logs_overview_web_screens-d1bd9a2728f9be275e6f10f00e377f10.png" />
</Frame>

The `Call Logs` is comprised of the following components:

| Components                                      | Description                                                                                                                 |
| ----------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------- |
| CometChatList                                   | a reusable container component having title, search box, customisable background and a List View                            |
| [cometchat-backdrop](/ui-kit/react/v4/backdrop) | This element represents the background against which other elements are presented.                                          |
| [CometChatListItem](/ui-kit/react/v4/list-item) | a component that renders data obtained from a Group object on a Tile having a title, subtitle, leading and trailing view    |
| [cometchat-date](/ui-kit/react/v4/date)         | This Component used to show the date and time. You can also customize the appearance of this widget by modifying its logic. |
| cometchat-button                                | This component represents a button with optional icon and text.                                                             |

## Usage

### Integration

<Tabs>
  <Tab title="CallLogDemo.tsx">
    ```typescript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      return <CometChatCallLogs />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="App.tsx">
    ```typescript theme={null}
    import { CallLogDemo } from "./CallLogDemo";

    export default function App() {
      return (
        <div className="App">
          <div>
            <CallLogDemo />
          </div>
        </div>
      );
    }
    ```
  </Tab>
</Tabs>

### Actions

[Actions](/ui-kit/react/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

#### 1. onItemClick

`OnItemClick` is triggered when you click on a ListItem of the Call Logs component. By default it initiate a call to the participant associated with the respective ListItem. You can override this action using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const handleOnItemClick = () => {
        console.log("custom on item click");
      };
      return <CometChatCallLogs onItemClick={handleOnItemClick} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const handleOnItemClick = () => {
        console.log("custom on item click");
      };
      return <CometChatCallLogs onItemClick={handleOnItemClick} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

#### 2. onInfoClick

`onInfoClick` is triggered when you click the Info button Icon of the `Call Logs` component. It does not have a default behavior. However, you can override its behavior using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const handleOnInfoClick = () => {
        console.log("custom on info click");
      };
      return <CometChatCallLogs onInfoClick={handleOnInfoClick} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const handleOnInfoClick = () => {
        console.log("custom on info click");
      };
      return <CometChatCallLogs onInfoClick={handleOnInfoClick} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

#### 3. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the Call Logs component.

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const handleOnError = () => {
        console.log("your custom on error actions");
      };
      return <CometChatCallLogs onError={handleOnError} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const handleOnError = () => {
        console.log("your custom on error actions");
      };
      return <CometChatCallLogs onError={handleOnError} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a `Component`. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using `RequestBuilders` of Chat SDK.

#### 1. CallLogRequestBuilder

The [CallLogRequestBuilder](/sdk/javascript/call-logs) enables you to filter and customize the Call Log based on available parameters in [CallLogRequestBuilder](/sdk/javascript/call-logs). This feature allows you to create more specific and targeted queries when fetching the call logs. The following are the parameters available in [CallLogRequestBuilder](/sdk/javascript/call-logs)

| Methods              | Type       | Description                                                  |
| -------------------- | ---------- | ------------------------------------------------------------ |
| **setLimit**         | number     | Specifies the number of call logs to fetch.                  |
| **setCallType**      | String     | Sets the type of calls to fetch (call or meet).              |
| **setCallStatus**    | callStatus | Sets the status of calls to fetch (initiated, ongoing, etc.) |
| **setHasRecording**  | boolean    | Sets whether to fetch calls that have recordings.            |
| **setCallCategory**  | string     | Sets the category of calls to fetch (call or meet).          |
| **setCallDirection** | string     | Sets the direction of calls to fetch (incoming or outgoing)  |
| **setUid**           | string     | Sets the UID of the user whose call logs to fetch.           |
| **setGuid**          | string     | Sets the GUID of the user whose call logs to fetch.          |
| **setAuthToken**     | string     | Sets the Auth token of the logged-in user.                   |

**Example**

In the example below, we're filtering Call Logs to show only canceled calls and setting the limit to five.

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CallLogRequestBuilder } from "@cometchat/calls-sdk-javascript";
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      return (
        <CometChatCallLogs
          callLogRequestBuilder={new CallLogRequestBuilder()
            .setAuthToken("authtoken")
            .setLimit(5)
            .setCallStatus("cancelled")}
        />
      );
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CallLogRequestBuilder } from "@cometchat/calls-sdk-javascript";
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      return (
        <CometChatCallLogs
          callLogRequestBuilder={new CallLogRequestBuilder()
            .setAuthToken("authtoken")
            .setLimit(5)
            .setCallStatus("cancelled")}
        />
      );
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/ui-kit/react/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The list of events emitted by the `Call Logs` component is as follows.

| Event             | Description                                                                                               |
| ----------------- | --------------------------------------------------------------------------------------------------------- |
| **ccMessageSent** | This event is triggered when the sent message is in transit and also when it is received by the receiver. |

***

<Tabs>
  <Tab title="Add Listener">
    ```javascript theme={null}
    const ccMessageSent = CometChatMessageEvents.ccMessageSent.subscribe(() => {
      //Your Code
    });
    ```
  </Tab>
</Tabs>

***

<Tabs>
  <Tab title="Remove Listener">
    ```javascript theme={null}
    ccMessageSent?.unsubscribe();
    ```
  </Tab>
</Tabs>

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Call Logs component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using Style you can customize the look and feel of the component in your app, These parameters typically control elements such as the color, size, shape, and fonts used within the component.

#### 1. CallLogs Style

To customize the appearance, you can assign a `CallLogsStyle` object to the `Call Logs` component.

**Example**

In this example, we are employing the `callLogsStyle`.

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs, CallLogsStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const callLogsStyle = new CallLogsStyle({
        background: "#dac6f5",
        titleColor: "#000000",
        dateTextColor: "#dac6f5",
      });
      return <CometChatCallLogs callLogsStyle={callLogsStyle} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs, CallLogsStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const callLogsStyle = new CallLogsStyle({
        background: "#dac6f5",
        titleColor: "#000000",
        dateTextColor: "#dac6f5",
      });
      return <CometChatCallLogs callLogsStyle={callLogsStyle} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bKHmaxDqzaJZWwLS/images/45a531d0-call_logs_style_web_screens-9a6dbef33948ea7e0df0cc0e679da14f.png?fit=max&auto=format&n=bKHmaxDqzaJZWwLS&q=85&s=112e114ab0936a315c5751e4902178a7" width="3600" height="2400" data-path="images/45a531d0-call_logs_style_web_screens-9a6dbef33948ea7e0df0cc0e679da14f.png" />
</Frame>

***

The following properties are exposed by `CallLogsStyle`:

| Property                   | Description                           | Code                               |
| -------------------------- | ------------------------------------- | ---------------------------------- |
| **border**                 | Used to set border                    | `border?: string,`                 |
| **borderRadius**           | Used to set border radius             | `borderRadius?: string;`           |
| **background**             | Used to set background colour         | `background?: string;`             |
| **height**                 | Used to set height                    | `height?: string;`                 |
| **width**                  | Used to set width                     | `width?: string;`                  |
| **titleFont**              | Used to set title font                | `titleFont?: string,`              |
| **titleColor**             | Used to set title color               | `titleColor?: string;`             |
| **emptyStateTextColor**    | Used to set empty state text color    | `emptyStateTextColor?: string;`    |
| **emptyStateTextFont**     | Used to set empty state text font     | `emptyStateTextFont?: string;`     |
| **errorStateTextColor**    | Used to set error state text color    | `errorStateTextColor?: string;`    |
| **errorStateTextFont**     | Used to set error state text font     | `errorStateTextFont?: string;`     |
| **loadingIconTint**        | Used to set loading icon tint         | `loadingIconTint?: string;`        |
| **infoIconTint**           | Used to set info icon tint            | `infoIconTint?: string;`           |
| **missedCallIconTint**     | Used to set missed call icon tint     | `missedCallIconTint?: string;`     |
| **outgoingCallIconTint**   | Used to set outgoing call icon tint   | `outgoingCallIconTint?: string;`   |
| **incomingCallIconTint**   | Used to set incoming call icon tint   | `incomingCallIconTint?: string;`   |
| **callStatusTextFont**     | Used to set call status text font     | `callStatusTextFont?: string;`     |
| **callStatusTextColor**    | Used to set call status text color    | `callStatusTextColor?: string;`    |
| **dateTextFont**           | Used to set date text font            | `dateTextFont?: string;`           |
| **dateTextColor**          | Used to set date text color           | `dateTextColor?: string;`          |
| **dateSeparatorTextFont**  | Used to set date separator text font  | `dateSeparatorTextFont?: string;`  |
| **dateSeparatorTextColor** | Used to set date separator text color | `dateSeparatorTextColor?: string;` |

#### 2. Avatar Style

If you want to apply customized styles to the `Avatar` component within the `Call Logs` Component, you can use the following code snippet. For more information you can refer [Avatar Styles](/ui-kit/react/v4/avatar#avatar-style).

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs, AvatarStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });
      return <CometChatCallLogs avatarStyle={avatarStyle} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs, AvatarStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });
      return <CometChatCallLogs avatarStyle={avatarStyle} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

#### 3. ListItem Style

If you want to apply customized styles to the `ListItemStyle` component within the `Call Logs` Component, you can use the following code snippet. For more information, you can refer [ListItem Styles](/ui-kit/react/v4/list-item#listitemstyle).

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs, ListItemStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid #cdc2ff",
      });
      return <CometChatCallLogs listItemStyle={listItemStyle} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs, ListItemStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid #cdc2ff",
      });
      return <CometChatCallLogs listItemStyle={listItemStyle} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

Here is a code snippet demonstrating how you can customize the functionality of the `Call Logs` component.

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      return (
        <CometChatCallLogs
          title="Your Custom Title"
          datePattern={DatePatterns.DayDateTime}
          hideSeparator={false}
        />
      );
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      return (
        <CometChatCallLogs
          title="Your Custom Title"
          datePattern={DatePatterns.DayDateTime}
          hideSeparator={false}
        />
      );
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Relz_yItqW5RHUsU/images/4e0b95ab-call_logs_functionality_default_web_screens-0853f993061a9b9b0d224c3d625afd7b.png?fit=max&auto=format&n=Relz_yItqW5RHUsU&q=85&s=28ad9268ec0e6269f13d896bd2d170e1" width="3600" height="2400" data-path="images/4e0b95ab-call_logs_functionality_default_web_screens-0853f993061a9b9b0d224c3d625afd7b.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/LKT8U_07JOWQgTZK/images/0d1ae652-call_logs_functionality_custom_web_screens-f1c16f2cc45fa0add6c194f52322b458.png?fit=max&auto=format&n=LKT8U_07JOWQgTZK&q=85&s=92afdd6d315881abb69015a22ecd9d42" width="3600" height="2400" data-path="images/0d1ae652-call_logs_functionality_custom_web_screens-f1c16f2cc45fa0add6c194f52322b458.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                     | Description                                        | Code                                                         |
| ---------------------------- | -------------------------------------------------- | ------------------------------------------------------------ |
| **title**                    | Used to set custom title                           | `title='Your Custom Title'`                                  |
| **emptyStateText**           | Used to set custom empty state text                | `emptyStateText='Your Custom Empty State Text'`              |
| **errorStateText**           | Used to set custom error state text                | `errorStateText='Your Custom Error State Text'`              |
| **titleAlignment**           | Used to set custom title alignment                 | `titleAlignment={TitleAlignment.center}`                     |
| **datePattern**              | Used to set custom date pattern                    | `datePattern={DatePatterns.DayDateTime}`                     |
| **dateSeparatorPattern**     | Used to set custom date separator pattern          | `dateSeparatorPattern={DatePatterns.DayDateTime}`            |
| **infoIconUrl**              | Used to set custom info icon                       | `infoIconUrl='Custom Info Icon URL'`                         |
| **incomingAudioCallIconUrl** | Used to set custom incoming audio call icon        | `incomingAudioCallIconUrl='Custom Incoming Audio Call Icon'` |
| **missedAudioCallIconUrl**   | Used to set custom missed audio call icon          | `missedAudioCallIconUrl='Custom Missed Audio Call Icon'`     |
| **missedVideoCallIconUrl**   | Used to set custom missed video call icon          | `missedVideoCallIconUrl='Custom Missed Video Call Icon'`     |
| **incomingVideoCallIconUrl** | Used to set custom incoming video call icon        | `incomingVideoCallIconUrl='Custom Incoming Video Call Icon'` |
| **outgoingAudioCallIconUrl** | Used to set custom outgoing audio call icon        | `outgoingAudioCallIconUrl='Custom Outgoing Audio Call Icon'` |
| **outgoingVideoCallIconUrl** | Used to set custom outgoing video call icon        | `outgoingVideoCallIconUrl='Custom Outgoing Video Call Icon'` |
| **loadingIconURL**           | Used to set custom loading icon                    | `loadingIconURL='Custom Loading Icon'`                       |
| **hideSeparator**            | Option to hide separator                           | `hideSeparator={false}`                                      |
| **activeCall**               | Used to set active Call that is currently selected | `activeCall={call}`                                          |

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### ListItemView

With this property, you can assign a custom ListItem to the Call Logs Component.

```javascript theme={null}
listItemView = { getListItemView };
```

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/6twnUcGNOB9c0CI0/images/ea2a27d3-call_logs_list_item_view_default_web_screens-506fa090bed2b8bf2afc7e9359467ef7.png?fit=max&auto=format&n=6twnUcGNOB9c0CI0&q=85&s=d711d6868832960cb8726eb875dd0527" width="3600" height="2400" data-path="images/ea2a27d3-call_logs_list_item_view_default_web_screens-506fa090bed2b8bf2afc7e9359467ef7.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tI1D0nyKUVcz2LEZ/images/c32ca3ec-call_logs_list_item_view_custom_web_screens-65efd5bab911e5af186833b607c06c33.png?fit=max&auto=format&n=tI1D0nyKUVcz2LEZ&q=85&s=59e70a25fc50d6eb1306cde9006d16c1" width="3600" height="2400" data-path="images/c32ca3ec-call_logs_list_item_view_custom_web_screens-65efd5bab911e5af186833b607c06c33.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CallLog } from "@cometchat/calls-sdk-javascript";
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getListItemView = (call: CallLog) => {
        if (call.getInitiator()) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "10px",
                border: "2px solid #e9baff",
                borderRadius: "20px",
                background: "#6e2bd9",
              }}
            >
              <cometchat-avatar
                image={call.getInitiator().getAvatar()}
                name={call.getInitiator().getName()}
              />
              <div style={{ display: "flex", paddingLeft: "10px" }}>
                <div
                  style={{ fontWeight: "bold", color: "#ffffff", fontSize: "14px" }}
                >
                  {call.getInitiator().getName()}
                </div>
              </div>
            </div>
          );
        } else {
          return <div>{call.getReceiver().getName()}</div>;
        }
      };

      return <CometChatCallLogs listItemView={getListItemView} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getListItemView = (call) => {
        if (call.getInitiator()) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "10px",
                border: "2px solid #e9baff",
                borderRadius: "20px",
                background: "#6e2bd9",
              }}
            >
              <cometchat-avatar
                image={call.getInitiator().getAvatar()}
                name={call.getInitiator().getName()}
              />
              <div style={{ display: "flex", paddingLeft: "10px" }}>
                <div
                  style={{ fontWeight: "bold", color: "#ffffff", fontSize: "14px" }}
                >
                  {call.getInitiator().getName()}
                </div>
              </div>
            </div>
          );
        } else {
          return <div>{call.getReceiver().getName()}</div>;
        }
      };
      return <CometChatCallLogs listItemView={getListItemView} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***

#### SubtitleView

You can customize the subtitle view for each call logs item to meet your requirements

```javascript theme={null}
subtitleView = { getSubtitleView };
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d228d043-call_logs_subtitle_view_default_web_screens-64218d28454cbb8ad6dad843f49f6e1b.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=4623a539e69181c293f302bfaa831d57" width="3600" height="2400" data-path="images/d228d043-call_logs_subtitle_view_default_web_screens-64218d28454cbb8ad6dad843f49f6e1b.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/DVg4aTljRFe0drLF/images/23667da7-call_logs_subtitle_view_custom_web_screens-38ac66906d044da9b6f34efc23348ecd.png?fit=max&auto=format&n=DVg4aTljRFe0drLF&q=85&s=123a183ba8809d4d27580865d5255699" width="3600" height="2400" data-path="images/23667da7-call_logs_subtitle_view_custom_web_screens-38ac66906d044da9b6f34efc23348ecd.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CallLog } from "@cometchat/calls-sdk-javascript";
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getSubtitleView = (call: CallLog): JSX.Element => {
        return (
          <div
            style={{
              display: "flex",
              alignItems: "left",
              padding: "2px",
              fontSize: "10px",
            }}
          >
            <div style={{ color: "gray", fontSize: "15px" }}>
              {call.getStatus()}
            </div>
          </div>
        );
      };

      return <CometChatCallLogs subtitleView={getSubtitleView} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getSubtitleView = (call) => {
        return (
          <div
            style={{
              display: "flex",
              alignItems: "left",
              padding: "2px",
              fontSize: "10px",
            }}
          >
            <div style={{ color: "gray", fontSize: "15px" }}>
              {call.getStatus()}
            </div>
          </div>
        );
      };

      return <CometChatCallLogs subtitleView={getSubtitleView} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***

#### TailView

You can customize the tail view for each call logs item to meet your requirements

```javascript theme={null}
tailView = { getTailView };
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/dDWpooIQ48haNjyU/images/7ab55640-call_logs_tailview_view_default_web_screens-5d23ec8c3c43e4d85b19db5c631ef366.png?fit=max&auto=format&n=dDWpooIQ48haNjyU&q=85&s=a69e886e8175344e906f081df99eafc3" width="3600" height="2400" data-path="images/7ab55640-call_logs_tailview_view_default_web_screens-5d23ec8c3c43e4d85b19db5c631ef366.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f42b1867-call_logs_tailview_view_custom_web_screens-0d61ad57a621b1e478592e2a4cdbf3da.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=563da6dc987d2a9f4123878251abb164" width="3600" height="2400" data-path="images/f42b1867-call_logs_tailview_view_custom_web_screens-0d61ad57a621b1e478592e2a4cdbf3da.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CallLog } from "@cometchat/calls-sdk-javascript";
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      function getTailView(call: CallLog): JSX.Element {
        function formatTime(timestamp: number) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        return (
          <div
            style={{
              color: "#5a00a8",
              border: "1px solid #5a00a8",
              borderRadius: "12px",
              padding: "5px",
            }}
          >
            {formatTime(call.getInitiatedAt())}
          </div>
        );
      }

      return <CometChatCallLogs tailView={getTailView} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      function getTailView(call) {
        function formatTime(timestamp) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        return (
          <div
            style={{
              color: "#5a00a8",
              border: "1px solid #5a00a8",
              borderRadius: "12px",
              padding: "5px",
            }}
          >
            {formatTime(call.getInitiatedAt())}
          </div>
        );
      }

      return <CometChatCallLogs tailView={getTailView} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***

#### LoadingStateView

You can set a custom loader view using `loadingStateView` to match the loading view of your app.

```javascript theme={null}
loadingStateView={getLoadingStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bKHmaxDqzaJZWwLS/images/45d3fdab-call_logs_loading_state_view_default_web_screens-e351ed40e0407382e07795621703c7f4.png?fit=max&auto=format&n=bKHmaxDqzaJZWwLS&q=85&s=eefba025c478444d6817e9037ce3140b" width="3600" height="2400" data-path="images/45d3fdab-call_logs_loading_state_view_default_web_screens-e351ed40e0407382e07795621703c7f4.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_oiGBuX1qG3S8Eo5/images/621fc1f7-call_logs_loading_state_view_custom_web_screens-bb7b4139c66933617278a187dbe17973.png?fit=max&auto=format&n=_oiGBuX1qG3S8Eo5&q=85&s=e0d80d7c75a02734013f624d5e771997" width="3600" height="2400" data-path="images/621fc1f7-call_logs_loading_state_view_custom_web_screens-bb7b4139c66933617278a187dbe17973.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CallLog } from "@cometchat/calls-sdk-javascript";
    import { CometChatCallLogs, LoaderStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getLoadingStateView = () => {
        const getLoaderStyle = new LoaderStyle({
          iconTint: "#890aff",
          background: "red",
          height: "100vh",
          width: "100vw",
          border: "none",
          borderRadius: "0",
        });

        return (
          <div style={{ background: "red", position: "absolute", top: "0" }}>
            <cometchat-loader
              iconURL="icon"
              loaderStyle={JSON.stringify(getLoaderStyle)}
            ></cometchat-loader>
          </div>
        );
      };

      return <CometChatCallLogs loadingStateView={getLoadingStateView()} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs, LoaderStyle } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getLoadingStateView = () => {
        const getLoaderStyle = new LoaderStyle({
          iconTint: "#890aff",
          background: "red",
          height: "100vh",
          width: "100vw",
          border: "none",
          borderRadius: "0",
        });

        return (
          <div style={{ background: "red", position: "absolute", top: "0" }}>
            <cometchat-loader
              iconURL="icon"
              loaderStyle={JSON.stringify(getLoaderStyle)}
            ></cometchat-loader>
          </div>
        );
      };

      return <CometChatCallLogs loadingStateView={getLoadingStateView()} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***

#### EmptyStateView

You can set a custom `EmptyStateView` using `emptyStateView` to match the empty view of your app.

```javascript theme={null}
emptyStateView={getEmptyStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/60KLvpM3Vx0byZeU/images/b71469f2-call_logs_empty_state_view_default_web_screens-c4ed8bfc7bc5278ef644505b9b3d010e.png?fit=max&auto=format&n=60KLvpM3Vx0byZeU&q=85&s=8d65373ce3fea0a11579e697aaa08610" width="3600" height="2400" data-path="images/b71469f2-call_logs_empty_state_view_default_web_screens-c4ed8bfc7bc5278ef644505b9b3d010e.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/iII-209mTdOytBSH/images/ee855e70-call_logs_empty_state_view_custom_web_screens-98d26242514a65dbfbf6fc41b0e9bf2f.png?fit=max&auto=format&n=iII-209mTdOytBSH&q=85&s=2c88c1bb4d0e9788c9c53f337a4d525e" width="3600" height="2400" data-path="images/ee855e70-call_logs_empty_state_view_custom_web_screens-98d26242514a65dbfbf6fc41b0e9bf2f.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getEmptyStateView = () => {
        return (
          <div style={{ color: "#d6cfff", fontSize: "30px", font: "bold" }}>
            Your Custom Empty State
          </div>
        );
      };

      return <CometChatCallLogs emptyStateView={getEmptyStateView()} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getEmptyStateView = () => {
        return (
          <div style={{ color: "#d6cfff", fontSize: "30px", font: "bold" }}>
            Your Custom Empty State
          </div>
        );
      };

      return <CometChatCallLogs emptyStateView={getEmptyStateView()} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***

#### ErrorStateView

You can set a custom `ErrorStateView` using `errorStateView` to match the error view of your app.

```javascript theme={null}
errorStateView={getErrorStateView()}
```

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="custom image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };

      return <CometChatCallLogs errorStateView={getErrorStateView()} />;
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import { CometChatCallLogs } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src="custom image"
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };

      return <CometChatCallLogs errorStateView={getErrorStateView} />;
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

## Configurations

[Configurations](/ui-kit/react/v4/components-overview#configurations) offer the ability to customize the properties of each component within a Composite Component.

CometChatCallLogs has `OutGoing Call` component. Hence, each of these components will have its individual \`Configuration\`\`.

* `Configurations` expose properties that are available in its individual components.

#### OutGoing Call

You can customize the properties of the OutGoing Call component by making use of the `OutgoingCallConfiguration`. You can accomplish this by employing the `outgoingCallConfiguration` props as demonstrated below:

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
    outgoingCallConfiguration={new OutgoingCallConfiguration({
      //override properties of out going call
    })}
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
    outgoingCallConfiguration={new OutgoingCallConfiguration({
      //override properties of out going call
    })}
    ```
  </Tab>
</Tabs>

All exposed properties of `OutgoingCallConfiguration` can be found under [OutGoing Call](/ui-kit/react/v4/outgoing-call#functionality). Properties marked with the [report]() symbol are not accessible within the Configuration Object.

**Example**

Let's say you want to change the style of the OutGoing Call subcomponent and, in addition, you want to change the decline button icon.

You can modify the style using the `outgoingCallStyle` property and set custom decline button icon using `declineButtonIconURL` property.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/FdElFhttTImVJEz7/images/e3e289c6-call_logs_outgoingcall_configuration_web_screens-1140f57d7ebed6c965f357d63aa35c7f.png?fit=max&auto=format&n=FdElFhttTImVJEz7&q=85&s=f5dc398de8763c29a766c6f32ab455df" width="3600" height="2400" data-path="images/e3e289c6-call_logs_outgoingcall_configuration_web_screens-1140f57d7ebed6c965f357d63aa35c7f.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CallLogDemo.tsx

    ```typescript theme={null}
    import {
      CometChatCallLogs,
      OutgoingCallConfiguration,
      OutgoingCallStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const outgoingCallStyle = new OutgoingCallStyle({
        background: "#e0d5f5",
        declineButtonIconBackground: "#6830d1",
        height: "500px",
        width: "300px",
        declineButtonTextColor: "#ffffff",
        titleTextColor: "#ffffff",
        subtitleTextColor: "#9213d6",
        declineButtonIconTint: "#dbb1f2",
        border: "1px solid #e6e6e6",
        borderRadius: "12px",
      });
      return (
        <CometChatCallLogs
          outgoingCallConfiguration={
            new OutgoingCallConfiguration({
              //override properties of out going call
              outgoingCallStyle: outgoingCallStyle,
              declineButtonIconURL: "custom decline button icon",
            })
          }
        />
      );
    };

    export default CallLogDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    CallLogDemo.jsx

    ```javascript theme={null}
    import {
      CometChatCallLogs,
      OutgoingCallConfiguration,
      OutgoingCallStyle,
    } from "@cometchat/chat-uikit-react";
    import React from "react";

    const CallLogDemo = () => {
      const outgoingCallStyle = new OutgoingCallStyle({
        background: "#e0d5f5",
        declineButtonIconBackground: "#6830d1",
        height: "500px",
        width: "300px",
        declineButtonTextColor: "#ffffff",
        titleTextColor: "#ffffff",
        subtitleTextColor: "#9213d6",
        declineButtonIconTint: "#dbb1f2",
        border: "1px solid #e6e6e6",
        borderRadius: "12px",
      });
      return (
        <CometChatCallLogs
          outgoingCallConfiguration={
            new OutgoingCallConfiguration({
              //override properties of out going call
              outgoingCallStyle: outgoingCallStyle,
              declineButtonIconURL: "custom decline button icon",
            })
          }
        />
      );
    };

    export default CallLogDemo;
    ```
  </Tab>
</Tabs>

***
